;###############################################################################
/* Control for LilBuilder

*/
;###############################################################################

Control_New(Type, GuiHWND, Content="", AddOptions=""){
  Static CtrlCnt = 0, PrevCtrlType

	;no Options handling yet... need to add that 

  CtrlCnt++                                                ;count controls continuesly 
  IfEqual, GuiID,
  GuiID := Gui(GuiHWND, "GuiID")                           

  If (!Content And !AddOptions){
   	Content := Type " Control " CtrlCnt                      ;default content
   	AddOptions = x0 y0
  	If Type = Picture                                        ;default content for picture
  		Content := A_WinDir "\Notepad.exe"
  	Else If Type in Progress,Slider                          ;default content for Progress, Slider
  		Content = 33
  	Else If Type in UpDown                                   ;default content for UpDown
  	  Content = 11
  	Else If Type in HotKey                                   ;default content for HotKey
  	  Content = ^c
  	Else If Type in ListBox,DropDownList,ComboBox            ;default content for ListBox,DropDownList,ComboBox
  	  Content .= "||Red|Green|Blue|Black|White"
  	Else If Type in DateTime                                 ;default content for DateTime
  	  Content = LongDate
  	Else If Type in MonthCal                                 ;default content for MonthCal
  	  Content = %A_Now%
    If Type in CheckBox,Radio,Text,Progress                  ;default height for CheckBox, Text and Radio
      AddOptions .= " h23"
  }

  If (Type = "Tab") {                                 ;prepare tab
    TabCnt := Gui(GuiHWND, "_TabCount")                   ;who many tabs are already on the gui
    TabCnt := TabCnt ? ++TabCnt : 1                       ;increase or set to 1
    Gui(GuiHWND, "_TabCount", TabCnt)                     ;store new value
 		Content = Tab%TabCnt%.1|Tab%TabCnt%.2
    AddOptions .= " AltSubmit"
  }
  Else If (Type = "UpDown" and PrevCtrlType <> "Edit") ;set updown isolated when no edit control wasn't added previously
    AddOptions .= " -16"                               ;isolate UpDown
  PrevCtrlType = %Type%

   StandardCtrls := ToolBox_StandardCtrls()                 ;get list of standard controls
   If Type in %StandardCtrls%                               ;when standard control
   {
      VarName := ToolBox_StandardCtrls(Type) "New" CtrlCnt   ;create CtrlID and control
      CtrlHWND := 0 + Control_Create(GuiID, Type, AddOptions " v" VarName, Content)
      StandardControl := True                                   ;set marker
   }
   Else {                                                   ;when not a standard control
      If Type = HiEdit
         CtrlHWND := 0 + HE_Add(GuiHWND, 0, 0, 300, 200)

      Else If Type = HLink
         CtrlHWND := 0 + HLink_Add(GuiHWND, 0, 0, 80, 20)

      Else If Type = RaGrid
      {
         CtrlHWND := 0 + RG_Add(GuiHWND, 0, 0, 220, 150, "VGRIDLINES GRIDLINES" )
         RG_AddColumn(CtrlHWND, "cap=Col1", "w=150" ), RG_AddColumn(CtrlHWND, "cap=Col2", "w=50")
         RG_SetHdrHeight(CtrlHWND, 25)
      }
      Else If Type = SpreadSheet
      {
			CtrlHWND := 0 + SS_Add(GuiHWND, 0, 0, 220, 150, "")
      }
      Else If Type = IE
      {
         pwb := IE_Add(GuiHWND, 0, 0, 200, 200)
         IE_LoadHTML(pwb, "<a href=""http://www.autohotkey.com/forum/viewtopic.php?t=19225&start=0"">IE Control</a>")
      }
   }
  Control(CtrlHWND,"Create")                                ;create a dictionary
  Control(CtrlHWND,"Type",Type)                             ;store its type
  If StandardControl {                                      ;for standard controls
    Control(CtrlHWND,"VarName",VarName)                          ;store CtrlID
    Control(CtrlHWND,"_FinalVarName","")                         ;store FinalCtrlID
    Control(CtrlHWND,"Disabled",False)                           ;store DisableState
    Control(CtrlHWND,"Hidden",False)                             ;store HiddenState
    Control(CtrlHWND,"Content",Content)                          ;store content
    If Type in CheckBox,Radio
      Control(CtrlHWND,"Checked",False)
    If (Type = "StatusBar")                                      ;special settings for statusbar
      Gui(GuiHWND, "_StatusBar", CtrlHWND)                             
    If (Type = "Tab"){                                           ;special settings for tabs
      Gui, %GuiID%:Tab                        ;by default no controls get added to tab
      Control(CtrlHWND,"_TabID",TabCnt)
      Control(CtrlHWND "T1","Create")         ;create tab page controls as subcontrols of tabs to hold controls
      Control(CtrlHWND "T1","Type","TabPage")
      Control(CtrlHWND "T2","Create")
      Control(CtrlHWND "T2","Type","TabPage")
    }
  }
  Else {
    ;??? custom controls properties
  }

  If ((Type != "StatusBar") AND (TabPageHWND := Tab_vActiveTabPage()) )
     Tab_AddControl2Page(TabPageHWND, CtrlHWND)    ;add control to list of controls on tab page
  Else
    Gui_AddControl(GuiHWND,CtrlHWND)          ;add control to list of controls on gui

  Return CtrlHWND
}

;create a control in a global context
Control_Create(GuiID, Type, Options, Content){
  local CtrlHWND
  Gui, %GuiID%:Add, %Type%, %Options% HWNDCtrlHWND, %Content%
  Return CtrlHWND
}

;set a control property and remove others simulatiously
Control_ExchangeProperties(CtrlHWND, PropertyName, NewValue, ValuesToRemove){
  Property := Control(CtrlHWND,PropertyName)
  Loop, Parse, ValuesToRemove, `,
      Property := RegExReplace(Property, "\b" A_LoopField "\b")
  Control(CtrlHWND,PropertyName, Property . NewValue)
}

;return Gui HWND of gui the control is on. Useful when control is on Tab page
Control_GetParentGuiHWND(CtrlHWND){             
  ParentHWND := Control(CtrlHWND,"BelongsTo")
  If (Pos := InStr(ParentHWND,"T"))
    ParentHWND := Control_GetParentGuiHWND(SubStr(ParentHWND,1,Pos - 1))
  Return ParentHWND
}

;return the pos/size of a control in gui coordinates
Control_GetPosSizeOnGui(CtrlHWND, ByRef PosX, ByRef PosY, ByRef PosW, ByRef PosH){
  GuiHWND := Control_GetParentGuiHWND(CtrlHWND)
  GuiID := Gui(GuiHWND,"GuiID")
  CtrlID := Control(CtrlHWND,"VarName")
  GuiControlGet, Pos, %GuiID%:Pos, %CtrlID%
}

;delete a list of controls 
Control_DeleteControlList(ListCtrlHWND){
  Loop, Parse, ListCtrlHWND, |                     ;go through control list
    If ("Tab" = Control(A_LoopField,"Type"))          ;delete tab
      Tab_DeleteItself(A_LoopField)
    Else                                              ;delete all other controls
      Control_Delete(A_LoopField)
}

;delete a control (visible, from list and its dic)
Control_Delete(CtrlHWND){
  If !CtrlHWND                                      ;only when there is a control
      Return
  If ("StatusBar" = Control(CtrlHWND,"Type")){      ;hide statusbar instead of delete, since a second can't be added later
    GuiHWND := Control(CtrlHWND,"BelongsTo")
    Gui(GuiHWND, "_StatusBar", -1 * Gui(GuiHWND, "_StatusBar"))  ;memorize deletion state by setting HWND negative
    GuiID := Gui(GuiHWND, "GuiID")
    CtrlID := Control(CtrlHWND,"VarName")
    GuiControl, %GuiID%:Hide, %CtrlID%                     ;hide statusbar
    Gui_RemoveControl(CtrlHWND)                            ;remove it from list of controls on gui
  }Else {
    DllCall("DestroyWindow", "uint", CtrlHWND)             ;destroy control on gui
    Gui_RemoveControl(CtrlHWND)                            ;remove control from list of controls on gui or tab
    Control(CtrlHWND,"Remove")                             ;remove controls dictionary
  }
}

Control_ApplyProp(GuiHWND, CtrlHWND, SubCommand, Param3 = ""){
  GuiID := Gui(GuiHWND, "GuiID")
  CtrlID := Control(CtrlHWND, "VarName")
  GuiControl, %GuiID%:%SubCommand%, %CtrlID%, %Param3%
}

Control_Anchor(g, c, a = "") {
	static d
  WinGetPos, , , gw, gh, ahk_id %g%
  ControlGetPos, px,py,pw,ph,, ahk_id %c%
	i = x.w.y.h./.7.%gw%.%gh%.`n%g%:%c%=
	StringSplit, i, i, .
	d := a ? d . ((n := !InStr(d, i9)) ? i9 : "")
		: RegExReplace(d, "\n\d+:" . c . "=[\-\.\d\/]+")
	Loop, 4
		x := A_Index, j := i%x%, i6 += x = 3
		, k := !RegExMatch(a, j . "([\d.]+)", v) + (v1 ? v1 : 0)
		, e := p%j% - i%i6% * k, d .= n ? e . i5 : ""
		, RegExMatch(d, "\Q" . i9 . "\E(?:([\d.\-]+)/){" . x . "}", v)
		, l .= p%j% := InStr(a, j) ?  v1 + i%i6% * k : ""
  ControlMove, , px, py, pw, ph, ahk_id %c%
}

;dictionary to store all control relevant properties.
Control(HWND,PropertyNameOrAction,Value="",Clear=""){
  Static MasterDic, init = 0

  If !init {  ;set up a master dic once to link HWNDs to their pDic
    init++
    MasterDic := Dic("insensitive")
  }

  If (HWND = "Remove" And PropertyNameOrAction = "All"){ ;delete all dics
    Loop{                                                ;delete all control dics
      If (HWND := Dic_NextKey(penum, MasterDic))
        Dic("delete", Dic_Get(MasterDic, HWND))
      If !penum
        Break
    }
    Dic("delete",MasterDic)                              ;delete master dic
    init = 0                                             ;reset init state
  }

  Else If (PropertyNameOrAction = "Remove"){   ;remove dic for control
    Dic("delete", Dic_Get(MasterDic, HWND))    ;delete the dic for the control
    Dic_Remove(MasterDic, HWND)                ;remove dic from master dic
  }

  Else If (PropertyNameOrAction = "Create")    ;create a dic for control
    Dic_Set(MasterDic, HWND, Dic("insensitive"))   ;store pDic of dic in master list under the HWND key

  Else If (PropertyNameOrAction = "AllPropertyNames"){ ;return all Property Names for control
    Loop, % Dic_Count(Dic_Get(MasterDic, HWND))
        AllPropertyNames .= "`n" . Dic_NextKey(ForInternalUse, Dic_Get(MasterDic, HWND))
    StringTrimLeft, AllPropertyNames, AllPropertyNames, 1
    Sort, AllPropertyNames
    Return AllPropertyNames  
  }

  Else If Value is not space                   ;assign value
    Dic_Set(Dic_Get(MasterDic, HWND), PropertyNameOrAction, Value)   ;get pDic from master dic and assign value

  Else If Clear is not space                   ;clear value
    Dic_Set(Dic_Get(MasterDic, HWND), PropertyNameOrAction, "")      ;get pDic from master dic and clear value

  Else                                         ;return value
    Return Dic_Get(Dic_Get(MasterDic, HWND), PropertyNameOrAction)   ;get pDic from master dic and return value
  
  Return 1
}

