;###############################################################################
/* ToolBox for LilBuilder

*/
;###############################################################################

;return toolbox own gui ID
Toolbox_vGuiID(){
  Return 2
}

;return toolbox own gui HWND
Toolbox_vHWND(NewHWND=""){
  static HWND
  If NewHWND
     HWND = %NewHWND%
  Return %HWND%
}

;return list of standard AHK controls 
ToolBox_StandardCtrls(AbbreviationType=""){
  static StandardControls := "Button,CheckBox,ComboBox,DateTime,DropDownList,Edit,GroupBox,HotKey,ListBox,ListView,MonthCal,Picture,Progress,Radio,Slider,StatusBar,Tab,Text,TreeView,UpDown"
       , Abbreviations := "Btn,Chk,Cbb,Dtm,Ddl,Edt,Grb,Htk,Lsb,Lsv,Moc,Pic,Prg,Rad,Sld,Stb,Tab,Txt,Trv,Upd"
  If AbbreviationType {
    StringSplit, Abbreviations, Abbreviations, `,
    Loop, Parse, StandardControls, `,
        If (AbbreviationType = A_LoopField)
            Return Abbreviations%A_Index%
  } Else
    Return StandardControls
}

;create ToolBox gui
Toolbox_Create() {
   local Toolbox_GuiID, Pos, StandardCtrls, CustomCtrls, Option, ShowText              ;global context
        , WorkArea, WorkAreaTop, WorkAreaLeft, WorkAreaRight, WorkAreaBottom
   Toolbox_GuiID := Toolbox_vGuiID()
   StandardCtrls := ToolBox_StandardCtrls()
   ShowText := Project("_ShowToolBoxIconText")
   CustomCtrls := "HiEdit,HLink,IE,RaGrid,SpreadSheet"
   
   Option := Project("_DockWindows") ? "+ToolWindow" : "" 
   Gui, %Toolbox_GuiID%:+LastFound +LabelToolbox_  %Option%
   Gui, %Toolbox_GuiID%:Margin, 3,4
   
   Gui, %Toolbox_GuiID%:Font, Bold
   Option := ShowText ? "w123" : "w65"
   Gui, %Toolbox_GuiID%:Add, Tab, Left %Option% h410, Standard|Custom
   Gui, %Toolbox_GuiID%:Font, Norm
     Gui, %Toolbox_GuiID%:Tab, Standard
        Option =
        Loop, Parse, StandardCtrls, `,
          {
            If A_Index > 1
              Option = xs
            Gui, %Toolbox_GuiID%:Add, Picture, %Option% Section gToolbox_OnClick vToolBox_Pic%A_LoopField%, res\Standard\%A_LoopField%.png
            If ShowText
              Gui, %Toolbox_GuiID%:Add, Text,x+5 gToolbox_OnClick vToolBox_Txt%A_LoopField%, %A_LoopField%
          }
     Gui, %Toolbox_GuiID%:Tab, Custom
        Option =
        Loop, Parse, CustomCtrls, `,
          {
            If A_Index > 1
              Option = xs
            Gui, %Toolbox_GuiID%:Add, Picture, %Option% Section gToolbox_OnClick vToolBox_Pic%A_LoopField%, res\Custom\%A_LoopField%.png
            If ShowText
              Gui, %Toolbox_GuiID%:Add, Text,x+5 gToolbox_OnClick vToolBox_Txt%A_LoopField%, %A_LoopField%
          }
   Gui, %Toolbox_GuiID%:Tab

   SysGet, WorkArea, MonitorWorkArea 
   Pos := Project("_DockWindows") ? "x-1000" : "x" WorkAreaLeft " y" WorkAreaTop
   Gui, %Toolbox_GuiID%:Show, %Pos%, ScriptName " - r" SVN_RevNum " " SVN_RevDate

   Toolbox_vHWND(WinExist() + 0)
}

;###############################################################################

ToolBox_Close:
 If !Project("_DockWindows")
    ExitApp
Return

;react on click on icon in toolbox
Toolbox_OnClick:
   Toolbox_OnClick()
return
Toolbox_OnClick() {
  If !(GuiHWND := Selector_vGuiHWND()){
      ToolTip("Please select a gui before you add a control",2000,"Continue")
      Return
    }
  Toolbox_GuiID := Toolbox_vGuiID()

  ;clear selection
  Selector_Size(False)
  Selector_vCtrlHWND("No")
  Selector_Set2PosSize(-10,-10)
  ToolTip_ShowTips4Pos("Hide")

  ;get type of control
  StringTrimLeft, Type, A_GuiControl, 11
  
  ;re-enable Statusbar when previously deleted but avoid two statusbars
  If (Type = "StatusBar" AND StatusBarHWND := Gui(GuiHWND, "_StatusBar")){
    If (StatusBarHWND < 0) {            ;if deleted
      StatusBarHWND *= -1
      Gui(GuiHWND, "_StatusBar", StatusBarHWND)      ;revert deletion state
      GuiID := Gui(GuiHWND, "GuiID")
      CtrlID := Control(StatusBarHWND,"VarName")
      GuiControl, %GuiID%:Show, %CtrlID%                  ;show statusbar
      Gui_AddControl(GuiHWND,StatusBarHWND)               ;add statusbar to list of controls on gui
    }
    Else                                             ;don't try to add a second
      ToolTip("Gui has already a Statusbar",2000,"Continue")
    Return
  }

  ;create the control
  CtrlHWND := Control_New(Type, GuiHWND)

  ;return for statusbar
  If (Type = "StatusBar")
      Return
  
  ;set control as selected
  Selector_vCtrlHWND(CtrlHWND)
  
  ;move mouse to center of control
  SysGet_GuiFrameSizes(Gui(GuiHWND,"Toolwindow"), XFrame, YFrame, HCaption)
  WinGetPos, ux, uy,,, ahk_id %GuiHWND%
  ControlGetPos, ,,cw,ch,, ahk_id %CtrlHWND%
  KeyWait, LButton     ;wait for release of LButton
  MouseMove, ux + cw // 2, uy + YFrame + HCaption + ch // 2

  Selector_Set2Ctrl()  ;set selector to control 

  Sleep, 20
  Selector_Size(True)
  Send {LButton down}  ;prepare movement
}

;###############################################################################

