;###############################################################################
/* Gui Context Menu for LilBuilder

*/
;###############################################################################

Gui_CreateMenu(Menu_Gui){
  MMenu_Add(Menu_Gui, "Change GuiID","","","iGui_ChangeGuiID")
  MMenu_Add(Menu_Gui, "Set Label","","","iGui_SetLabel")
  MMenu_Add(Menu_Gui, "As Toolwindow","","","iGui_SetAsToolWindow")
  MMenu_Add(Menu_Gui, "Resize","","","iGui_ToggleStateResize")
  MMenu_Add(Menu_Gui, "AlwaysOnTop","","","iGui_ToggleStateAlwaysOnTop")
  MMenu_Add(Menu_Gui, "Hidden","","","iGui_ToggleStateHidden")
  MMenu_Add(Menu_Gui, "Change Title","","","iGui_ChangeWindowTitle")
  MMenu_Add(Menu_Gui, "Custom Grid Size","","","iGui_CustomGridSize")
  MMenu_Add(Menu_Gui)
  MMenu_Add(Menu_Gui, "Delete Gui","","","iGui_Delete")
}

Gui_ShowMenu:
  Gui_UpdateGuiMenu(Menu_Gui, Menu_vGuiHWND())
  MMenu_Show(Menu_Gui, Menu_vX(), Menu_vY(), "Gui_OnSelection")
Return

Gui_OnSelection:
  If MMenu_ID = Gui_SetAsToolWindow
    Gui_SetAsToolWindow(Menu_vGuiHWND())
  Else If RegExMatch(MMenu_ID,"^Gui_ToggleState(Resize|AlwaysOnTop|Hidden)$")
    Gui_ToggleState(Menu_vGuiHWND(), MMenu_Title)
  Else If MMenu_ID = Gui_ChangeGuiID
    Gui_ChangeGuiID(Menu_vGuiHWND())
  Else If MMenu_ID = Gui_SetLabel
    Gui_SetLabel(Menu_vGuiHWND())
  Else If MMenu_ID = Gui_ChangeWindowTitle
    Gui_ChangeWindowTitle(Menu_vGuiHWND())
  Else If MMenu_ID = Gui_CustomGridSize
    Gui_CustomGridSize(Menu_vGuiHWND())
  Else If MMenu_ID = Gui_Delete
    Gui_Delete(Menu_vGuiHWND())
  Else If IsLabel(MMenu_ID)
    GoSub, %MMenu_ID%
Return

Gui_UpdateGuiMenu(Menu_Gui, GuiHWND){
  GuiID := Gui(GuiHWND,"_FinalGuiID")
  MMenu_Set(Menu_Gui,"Gui_ChangeGuiID","Change GuiID: " GuiID)

  Label := Gui(GuiHWND,"Label")
  Text := Label ? "Change Label: " Label : "Set Label"
  MMenu_Set(Menu_Gui,"Gui_SetLabel", Text)

  Content := Gui(GuiHWND,"Content")
  MMenu_Set(Menu_Gui,"Gui_ChangeWindowTitle","Change Title: " Content)

  CheckStatus := Gui(GuiHWND,"Toolwindow") ? "+c" : "-c"
  MMenu_Set(Menu_Gui,"Gui_SetAsToolWindow","","",CheckStatus )

  Toggles = Resize|AlwaysOnTop|Hidden
  Loop, Parse, Toggles , |
  {
    CheckStatus := Gui(GuiHWND,A_LoopField) ? "+c" : "-c"
    MMenu_Set(Menu_Gui,"Gui_ToggleState" A_LoopField,"","",CheckStatus )
  }

  GridSize := Grid(GuiHWND)
  Text := "Custom Grid Size" ( GridSize ? ": " GridSize : "")
  MMenu_Set(Menu_Gui,"Gui_CustomGridSize",Text)
}

Gui_ChangeGuiID(GuiHWND){
  GuiID := Gui(GuiHWND,"_FinalGuiID")
  
  InputBox, NewGuiID, Change GuiID, Specify an new unique gui ID, , , , Menu_vX(), Menu_vY(), , , %GuiID%
  If (NewGuiID AND NewGuiID <> GuiID AND Gui_IsGuiIDUnique(NewGuiID)){
    Gui(GuiHWND,"_FinalGuiID", NewGuiID)
    Gui_ChangeWindowTitle(GuiHWND,"update")
  }
}

Gui_SetLabel(GuiHWND){
  Label := Gui(GuiHWND,"Label")
  InputBox, NewLabel, Change Gui Label, Specify a gui label.`nNothing will remove label., , , , Menu_vX(), Menu_vY(), , , %Label%
  Gui(GuiHWND,"Label", NewLabel, NewLabel ? "" : "Clear")
  ;when ProjectName is default value, use new GuiLabel as ProjectName
  If (NewLabel AND "NewProject" = Project("ProjectName"))
      Project("ProjectName", NewLabel)
}

Gui_SetAsToolWindow(GuiHWND){
  Status := Gui(GuiHWND,"Toolwindow")
  Gui(GuiHWND,"Toolwindow", !Status)

  GuiID := Gui(GuiHWND,"GuiID")
  Status := Status ? "-" : "+"
  Gui, %GuiID%:%Status%Toolwindow
}

Gui_ToggleState(GuiHWND,Prop){
  Gui(GuiHWND,Prop, !Gui(GuiHWND,Prop))
}

Gui_ChangeWindowTitle(GuiHWND, Update=""){
  Content := Gui(GuiHWND,"Content")

  If Update
    NewContent = %Content%
  Else
    InputBox, NewContent, Change Window Title, Specify an new Title, , , , Menu_vX(), Menu_vY(), , , %Content%
  If (Update OR (NewContent AND NewContent <> Content)){
    GuiID := Gui(GuiHWND,"GuiID")
    FinalGuiID := Gui(GuiHWND,"_FinalGuiID")
    Gui, %GuiID%:Show,,ID = %FinalGuiID%`, Title = %NewContent%
    Gui(GuiHWND,"Content", NewContent)
  }
}

Gui_CustomGridSize(GuiHWND){
  OldGRID := Grid(GuiHWND)
  InputBox, NewGRID, Custome Grid Size, Specify an new grid size, , , , Menu_vX(), Menu_vY(), , , %OldGRID%
  If NewGRID is not integer
    Return
  If (NewGRID AND NewGRID <> OldGRID){
    Grid(GuiHWND, NewGRID)
    Grid_Draw(GuiHWND)
  }
}
