;###############################################################################
/* ListView for LilBuilder

*/
;###############################################################################

ListView_CreateMenu(Menu_ListView){
  MMenu_Add(Menu_ListView, "&Add column","","","iListView_AddColumn") 
}

ListView_ShowMenu: 
  CommonMenu_UpdateMenu(Menu_ListView) 
  ListView_FillListViewColumns(Menu_ListView)
  MMenu_Show(Menu_ListView, Menu_vX(), Menu_vY(), "ListView_OnSelection")
Return

ListView_OnSelection: 
  If MMenu_ID = ListView_AddColumn 
    ListView_AddColumn(Menu_vGuiHWND(), Menu_vCtrlHWND()) 
  Else If (InStr(MMenu_ID,"Menu_ListViewEdit_Delete")=1)
    ListView_DeleteColumn(Menu_vGuiHWND(), Menu_vCtrlHWND(), SubStr(MMenu_ID, 25))
  Else If (InStr(MMenu_ID,"Menu_ListViewEdit_Rename")=1)
    ListView_RenameColumn(Menu_vGuiHWND(), Menu_vCtrlHWND(), SubStr(MMenu_ID, 25))
  Else if IsLabel(MMenu_ID) 
    GoSub, %MMenu_ID% 
Return 

;############################################################################### 

ListView_FillListViewColumns(Menu_ListView){
  static Menu_ListViewColumns
  
  ;if already exists.. (like when user didn't select something from previous rClick..)
  If Menu_ListViewColumns {
    MMenu_Remove(Menu_ListView,"&Edit Columns ")
    MMenu_Destroy(Menu_ListViewColumns)
  }
  Menu_ListViewColumns := MMenu_Create()
  MMenu_Add(Menu_ListView, "&Edit Columns","","","m" Menu_ListViewColumns)

  CtrlHWND := Menu_vCtrlHWND()
  Content := Control(CtrlHWND, "Content") 
  Loop, Parse, Content, |
  { 
    Menu_ListViewEdit_%A_Index% := MMenu_Create()
    MMenu_Add(Menu_ListViewEdit_%A_Index%, "&Delete"    ,"","","iMenu_ListViewEdit_Delete" . A_Index)
    MMenu_Add(Menu_ListViewEdit_%A_Index%, "&Rename"    ,"","","iMenu_ListViewEdit_Rename" . A_Index)
    MMenu_Add(Menu_ListViewColumns, A_Index . "- " . A_LoopField,"","","m" Menu_ListViewEdit_%A_Index%) 
  } 
} 

ListView_AddColumn(GuiHWND, CtrlHWND) { 
  GuiID := Gui(GuiHWND, "GuiID") 
  CtrlID := Control(CtrlHWND, "VarName") 
  Gui, %GuiID%:Default 
  Gui, %GuiID%:ListView, %CtrlID%
  Col := 1 + LV_GetCount("Column") 
  LV_InsertCol(Col, "AutoHdr", "New Col") 
  Loop, %Col%
    LV_ModifyCol(A_Index,"AutoHdr") 

  ;update property 
  Content := Control(CtrlHWND,"Content") 
  Control(CtrlHWND,"Content", Content "|New Col") 
} 

ListView_DeleteColumn(GuiHWND, CtrlHWND, ID) { 
  GuiID := Gui(GuiHWND, "GuiID") 
  CtrlID := Control(CtrlHWND, "VarName") 
  Gui, %GuiID%:Default 
  Gui, %GuiID%:ListView, %CtrlID% 
  LV_DeleteCol(ID) 

  ;update property 
  Content := Control(CtrlHWND,"Content") 
  Loop, Parse, Content, | 
  { 
    If (A_Index <> ID) { 
      NewContent .= NewContent ? "|" . A_LoopField : A_LoopField 
      LV_ModifyCol(A_Index,"AutoHdr") 
    } 
  } 
  Control(CtrlHWND,"Content", NewContent) 
} 

ListView_RenameColumn(GuiHWND, CtrlHWND, ID) { 
  GuiID := Gui(GuiHWND, "GuiID") 
  CtrlID := Control(CtrlHWND, "VarName") 
  Gui, %GuiID%:Default 
  Gui, %GuiID%:ListView, %CtrlID% 
  Content := Control(CtrlHWND,"Content") 
  StringSplit, ColArray, Content, | 

  InputBox, ColArray%ID%, Rename Columns Page, Specify new names for columns., , , , Menu_vX(), Menu_vY(), , 
        , % ColArray%ID% 

  If !ErrorLevel  ;..else user canceled.. 
  { 
    LV_ModifyCol(ID, "AutoHdr", ColArray%ID%) 

    ;update property 
    Loop, % ColArray0 
    { 
      NewContent .= NewContent ? "|" ColArray%A_Index% : ColArray%A_Index% 
      LV_ModifyCol(A_Index,"AutoHdr") 
    } 
    Control(CtrlHWND,"Content", NewContent) 
  } 
} 
