;###############################################################################
/* Toolbox Context Menu for LilBuilder

*/
;###############################################################################

Toolbox_CreateMenu(Menu_Toolbox, Menu_ToolboxShowGuis, Menu_ToolboxDeleteGuis){
  MMenu_Add(Menu_Toolbox, "Add New Gui","","","iToolBox_AddNewGui")
  MMenu_Add(Menu_Toolbox, "Show Gui","","","m" Menu_ToolboxShowGuis)
  MMenu_Add(Menu_Toolbox, "Delete Gui","","","m" Menu_ToolboxDeleteGuis)
  MMenu_Add(Menu_Toolbox)
  MMenu_Add(Menu_Toolbox, "Export Project","","","iExportGui_Create")
  MMenu_Add(Menu_Toolbox, "Import Project","","","iSaveLoad_ImportProject")
  MMenu_Add(Menu_Toolbox, "Gui Stealer","","","iSaveLoad_StealImport")
  MMenu_Add(Menu_Toolbox)
  MMenu_Add(Menu_Toolbox, "Show ToolTip for Position and Size","","","iToolbox_ShowTips4Pos")
  MMenu_Add(Menu_Toolbox)
  MMenu_Add(Menu_Toolbox, "Li'l Builder Options","","","iIniSettingsEditor_Options")
}

Toolbox_ShowMenu:
  Toolbox_PrepareMenu(Menu_Toolbox, Menu_ToolboxShowGuis, Menu_ToolboxDeleteGuis)
  MMenu_Show(Menu_Toolbox, Menu_vX(), Menu_vY(), "Toolbox_OnSelection")
Return

Toolbox_OnSelection:
  If MMenu_ID = Toolbox_ShowTips4Pos
    Toolbox_ShowTips4Pos()
  Else If InStr(MMenu_ID,"ToolBox_ShowGui_") = 1
    ToolBox_ShowGui(SubStr(MMenu_ID,17))
  Else If InStr(MMenu_ID,"ToolBox_DeleteGui_") = 1
    Gui_Delete(SubStr(MMenu_ID,19))
  Else If MMenu_ID = ToolBox_AddNewGui
    Gui_Create()
  Else If MMenu_ID = ExportGui_Create
    ExportGui_Create()
  Else If MMenu_ID = SaveLoad_ImportProject
    SaveLoad_ImportProject()
  Else If MMenu_ID = SaveLoad_StealImport
    SaveLoad_StealImport()
  Else If MMenu_ID = IniSettingsEditor_Options
  {
    IniSettingsEditor("Li'l Builder",A_ScriptDir "\Settings.ini", 1, 1)
    LilBuilder_InitializeValues()
  }
  Else If IsLabel(MMenu_ID)
    GoSub, %MMenu_ID%
Return

Toolbox_PrepareMenu(Menu_Toolbox, Menu_ToolboxShowGuis, Menu_ToolboxDeleteGuis){
  CheckStatus := ToolTip_ShowTips4Pos("ReturnState") ? "+c" : "-c"
  MMenu_Set(Menu_Toolbox,"Toolbox_ShowTips4Pos","","",CheckStatus )
  
  MMenu_RemoveAll(Menu_ToolboxShowGuis)
  MMenu_RemoveAll(Menu_ToolboxDeleteGuis)
  ListOfGuiHWND := Project("ListOfGuiHWND")
  Loop, Parse, ListOfGuiHWND, |
  {
     MMenu_Add(Menu_ToolboxShowGuis
              , Gui(A_LoopField,"_FinalGuiID") ": " Gui(A_LoopField,"Content")
              ,"","","iToolBox_ShowGui_" Gui(A_LoopField,"GuiID"))  
     MMenu_Add(Menu_ToolboxDeleteGuis
              , Gui(A_LoopField,"_FinalGuiID") ": " Gui(A_LoopField,"Content")
              ,"","","iToolBox_DeleteGui_" A_LoopField)
  } 
}

Toolbox_ShowTips4Pos(){
  If (CurrentState := ToolTip_ShowTips4Pos("ReturnState"))
    ToolTip_ShowTips4Pos("Hide")
  ToolTip_ShowTips4Pos(!CurrentState)
  If (!CurrentState AND Selector_vCtrlHWND())
    ToolTip_ShowTips4Pos()
}

ToolBox_ShowGui(GuiID){
  Gui, %GuiID%:Show
}
